## openj9-21 0.56.0

=== openj9/runtime/CMakeLists.txt ===
################################################################################
# Copyright IBM Corp. and others 2017
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
################################################################################

###
### Basic housekeeping stuff
### i.e. things which need to be set up before including J9vmPlatform
###

include(cmake/version.cmake)

project(j9vm VERSION ${J9VM_VERSION} LANGUAGES CXX C)

# Tell newer versions of CMake that we expect the old behavior of CMP0079
if(POLICY CMP0079)
	cmake_policy(SET CMP0079 OLD)
endif()

set(J9VM_OMR_DIR "${CMAKE_CURRENT_SOURCE_DIR}/omr" CACHE PATH "Path to the OMR directory")
set(CMAKE_MODULE_PATH "${j9vm_SOURCE_DIR}/cmake/modules" "${J9VM_OMR_DIR}/cmake/modules" ${CMAKE_MODULE_PATH})

# pull in definitions of what options we support
include(cmake/options.cmake)

# ensure that we apply omr configuration early so any overrides we might set apply properly
include(cmake/omr_config.cmake)

###
### End basic housekeeping
###

# Get platform specific configuration stuff
include(cmake/platform.cmake)

# Pull in definitions for omr_add_hookgen and omr_add_tracegen
# these will be in omr/cmake/modules
include(OmrHookgen)
set(OMR_TRACE_ROOT "${CMAKE_CURRENT_BINARY_DIR}")
include(cmake/J9vmTargetSupport.cmake)
include(OmrTracegen)
include(OmrDDRSupport)
include(cmake/build_tags.cmake)
include(cmake/J9vmGenAsm.cmake)

###
### Various configuration
### all configuration that does not need to proceed J9vmPlatform
###

# Set up an interface library to keep track of the various compiler defines
# used by the jit components.
# TODO should probably rename to j9vm_jit_defines for less ambiguity

j9vm_add_library(j9vm_compiler_defines INTERFACE)
target_compile_definitions(j9vm_compiler_defines INTERFACE ${TR_COMPILE_DEFINITIONS})

# Build everything with -fPIC (or equivalent).
# We do this to ensure that our static libraries get built with -fPIC
# (cmake automatically builds shared libraries with -fPIC)
# TODO this has the side effect that we also build executables with -fPIE which we don't want.
# Need to investigate if it's possible to get one without the other. If it's not we need
# to explicitly tag individual targets which seems tedious.
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(OMR_OS_OSX)
	set(CMAKE_INSTALL_RPATH "@loader_path")
else()
	set(CMAKE_INSTALL_RPATH "\$ORIGIN")
endif()

set(OMR_INSTALL_PREFIX "${CMAKE_CURRENT_SOURCE_DIR}" CACHE STRING "")
set(CMAKE_INSTALL_PREFIX "${CMAKE_CURRENT_SOURCE_DIR}" CACHE STRING "" FORCE)

set(OMR_INSTALL_BIN_DIR "${j9vm_SOURCE_DIR}" CACHE PATH "")
set(OMR_INSTALL_LIB_DIR "${j9vm_SOURCE_DIR}" CACHE PATH "")
set(OMR_INSTALL_ARCHIVE_DIR "${j9vm_SOURCE_DIR}/lib" CACHE PATH "")

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/lib")
# we also want to set the RPATH properly
set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

if(OPENJ9_BUILD)
	add_definitions(-DOPENJ9_BUILD)
endif()

###
### Handle Generated files
###

configure_file(include/j9cfg.h.in j9cfg.h)
configure_file(include/j9lib.h.in j9lib.h)
configure_file(include/j9version.h.in j9version.h)
configure_file(makelib/copyright.c.in copyright.c)

# Definition of add_hookgen pulled in from omr/cmake/modules/OmrHookgen.cmake
# Here we handle all the .hdf files which don't have a more logical home.
# i.e. they live in directories where we don't need to build anything
# and/or its hard to track down exactly who depends on them

omr_add_hookgen(INPUT oti/j9jit.hdf)
omr_add_hookgen(INPUT oti/j9vm.hdf)
omr_add_hookgen(INPUT oti/zipCachePool.hdf)
omr_add_hookgen(INPUT gc_include/j9mm.hdf)

# Wrap up the hookgen'd files in a named target
# This is to work around the fact that CMake does not do proper dependency tracking
# for generated files across different directories.
add_custom_target(j9vm_hookgen
	DEPENDS
		${CMAKE_CURRENT_BINARY_DIR}/jithook.h
		${CMAKE_CURRENT_BINARY_DIR}/vmhook.h
		${CMAKE_CURRENT_BINARY_DIR}/vmzipcachehook.h
		${CMAKE_CURRENT_BINARY_DIR}/mmhook.h
)

# Generate NLS headers
file(GLOB_RECURSE nls_files "${CMAKE_CURRENT_SOURCE_DIR}/nls/*.nls")
add_custom_command(
	OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/nls.stamp"
	DEPENDS j9nls ${nls_files}
	COMMAND "${Java_JAVA_EXECUTABLE}" -cp "$<TARGET_PROPERTY:j9nls,JAR_FILE>" com.ibm.oti.NLSTool.J9NLS -source "${CMAKE_CURRENT_SOURCE_DIR}"
	COMMAND "${CMAKE_COMMAND}" -E touch "${CMAKE_CURRENT_BINARY_DIR}/nls.stamp"
	COMMENT "Generating NLS files"
	VERBATIM
)
add_custom_target(j9vm_nlsgen
	DEPENDS
		"${CMAKE_CURRENT_BINARY_DIR}/nls.stamp"
)

set(J9VM_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}/include")
file(MAKE_DIRECTORY "${J9VM_INCLUDE_DIR}")

# Note: the following does not appear to be needed anymore. It is left here in case we need it in the future.
# On z/OS, some generated files must be converted to EBCDIC for consistency.
# This macro is intended to be used as a replacement for add_custom_command
# for those files.
if("FALSE" AND OMR_OS_ZOS)
	macro(add_custom_ascii_command)
		set(options)
		set(singleValueArgs OUTPUT WORKING_DIRECTORY)
		set(multiValueArgs COMMAND DEPENDS)
		cmake_parse_arguments(opt "${options}" "${singleValueArgs}" "${multiValueArgs}" ${ARGN})

		add_custom_command(OUTPUT "${opt_OUTPUT}"
			DEPENDS ${opt_DEPENDS}
			COMMAND ${opt_COMMAND}
			COMMAND iconv -f ISO8859-1 -t IBM-1047 < "${opt_OUTPUT}" > "${opt_OUTPUT}.tmp"
			COMMAND mv -f "${opt_OUTPUT}.tmp" "${opt_OUTPUT}"
			COMMAND chtag -t -c IBM-1047 "${opt_OUTPUT}"
			VERBATIM
			WORKING_DIRECTORY "${opt_WORKING_DIRECTORY}"
		)
	endmacro(add_custom_ascii_command)
else()
	macro(add_custom_ascii_command)
		set(options)
		set(singleValueArgs OUTPUT WORKING_DIRECTORY)
		set(multiValueArgs COMMAND DEPENDS)
		cmake_parse_arguments(opt "${options}" "${singleValueArgs}" "${multiValueArgs}" ${ARGN})

		add_custom_command(OUTPUT "${opt_OUTPUT}"
			DEPENDS ${opt_DEPENDS}
			COMMAND ${opt_COMMAND}
			VERBATIM
			WORKING_DIRECTORY "${opt_WORKING_DIRECTORY}"
		)
	endmacro(add_custom_ascii_command)
endif()

# generate headers

add_custom_ascii_command(OUTPUT "${J9VM_INCLUDE_DIR}/jni.h"
	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/include/jni.h.m4"
	COMMAND m4 -D "JAVA_SPEC_VERSION=${JAVA_SPEC_VERSION}" "${CMAKE_CURRENT_SOURCE_DIR}/include/jni.h.m4" ${ASCII_TO_NATIVE} > "jni.h"
	VERBATIM
	WORKING_DIRECTORY "${J9VM_INCLUDE_DIR}"
)
add_custom_ascii_command(OUTPUT "${J9VM_INCLUDE_DIR}/jvmti.h"
	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/include/jvmti.h.m4"
	COMMAND m4 -D "JAVA_SPEC_VERSION=${JAVA_SPEC_VERSION}" "${CMAKE_CURRENT_SOURCE_DIR}/include/jvmti.h.m4" ${ASCII_TO_NATIVE} > "jvmti.h"
	VERBATIM
	WORKING_DIRECTORY "${J9VM_INCLUDE_DIR}"
)

# Generate zOS 31/64-bit interoperability compatible jni.h and copy other dependent headers.
if(J9VM_ZOS_3164_INTEROPERABILITY)
	set(J9VM_INCLUDE31_DIR "${CMAKE_CURRENT_BINARY_DIR}/include31")
	file(MAKE_DIRECTORY "${J9VM_INCLUDE31_DIR}")
	file(INSTALL "${CMAKE_CURRENT_SOURCE_DIR}/include/jni_convert.h" "${CMAKE_CURRENT_SOURCE_DIR}/include/jniport.h"
		DESTINATION "${J9VM_INCLUDE31_DIR}")

	add_custom_ascii_command(OUTPUT "${J9VM_INCLUDE31_DIR}/jni.h"
		DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/include/jni.h.m4"
		COMMAND m4 -D "J9_ZOS_3164_INTEROPERABILITY=1" -D "JAVA_SPEC_VERSION=${JAVA_SPEC_VERSION}" "${CMAKE_CURRENT_SOURCE_DIR}/include/jni.h.m4" ${ASCII_TO_NATIVE} > "jni.h"
		VERBATIM
		WORKING_DIRECTORY "${J9VM_INCLUDE31_DIR}"
	)

	add_custom_target(j9vm31_m4gen
		DEPENDS
			"${J9VM_INCLUDE31_DIR}/jni.h"
	)
endif()

# Note we do this here rather than in the redirector directory to work around
# issues in cmake. If we did it there each target which consumed generated.c would need
# its own rule to create it, which leads race conditions when building in parallel.

add_custom_ascii_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/redirector/generated.c"
	DEPENDS oti/helpers.m4 redirector/forwarders.m4 redirector/generated.c.m4
	COMMAND m4 -I "${CMAKE_CURRENT_SOURCE_DIR}/oti" -I "${CMAKE_CURRENT_SOURCE_DIR}/redirector" "${CMAKE_CURRENT_SOURCE_DIR}/redirector/generated.c.m4" > generated.c
	VERBATIM
	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/redirector"
)

add_custom_ascii_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/j9vm/generated.h"
	DEPENDS oti/helpers.m4 redirector/forwarders.m4 j9vm/generated.h.m4
	COMMAND m4 -I "${CMAKE_CURRENT_SOURCE_DIR}/oti" -I "${CMAKE_CURRENT_SOURCE_DIR}/redirector" "${CMAKE_CURRENT_SOURCE_DIR}/j9vm/generated.h.m4" > generated.h
	VERBATIM
	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/j9vm"
)

add_custom_target(j9vm_m4gen
	DEPENDS
		"${CMAKE_CURRENT_BINARY_DIR}/redirector/generated.c"
		"${CMAKE_CURRENT_BINARY_DIR}/j9vm/generated.h"
		"${J9VM_INCLUDE_DIR}/jni.h"
		"${J9VM_INCLUDE_DIR}/jvmti.h"
)

add_custom_target(copy_default_options ALL
	COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/options.default" "${CMAKE_CURRENT_BINARY_DIR}/options.default"
)

###
### Helper interface libraries
###

# j9vm_interface is used to hold properties we want to apply to everyone.
# e.g. adding oti/ to the include path etc.
j9vm_add_library(j9vm_interface INTERFACE)
target_include_directories(j9vm_interface
	INTERFACE
		${CMAKE_CURRENT_SOURCE_DIR}/oti
		${CMAKE_CURRENT_SOURCE_DIR}/include
		${J9VM_OMR_DIR}/include_core
		${J9VM_OMR_DIR}/gc/include
		${CMAKE_CURRENT_BINARY_DIR}/include
		${CMAKE_CURRENT_BINARY_DIR}/omr
		${CMAKE_CURRENT_BINARY_DIR}
		${CMAKE_BINARY_DIR}
)
# Inject copyright file if building a shared library or executable
set(is_executable "$<STREQUAL:$<TARGET_PROPERTY:TYPE>,EXECUTRABLE>")
set(is_shlib "$<STREQUAL:$<TARGET_PROPERTY:TYPE>,SHARED_LIBRARY>")
target_sources(j9vm_interface
	INTERFACE
		$<$<OR:${is_shlib},${is_executable}>:${CMAKE_CURRENT_BINARY_DIR}/copyright.c>
)

# If on z/OS link against omr_ascii, this is what gives us convlit(ISO8859-1) and links j9atoe
if(OMR_OS_ZOS)
	target_link_libraries(j9vm_interface INTERFACE omr_ascii)
endif()

target_include_directories(j9vm_interface INTERFACE ${CMAKE_CURRENT_BINARY_DIR}/nls)

add_dependencies(j9vm_interface
	j9vm_hookgen
	j9vm_m4gen
	j9vm_nlsgen
	run_tracegen
)

# j9vm_gc_includes is used to track the include directories that are consumed by the various gc components
j9vm_add_library(j9vm_gc_includes INTERFACE)
target_include_directories(j9vm_gc_includes
	INTERFACE
		# Pull in the public include paths exposed by the omrgc library
		$<TARGET_PROPERTY:omrgc,INTERFACE_INCLUDE_DIRECTORIES>
		# And then the include paths for the code we add ontop of the base omrgc
		${j9vm_SOURCE_DIR}/gc_include
		${j9vm_SOURCE_DIR}/gc_glue_java
		${j9vm_SOURCE_DIR}/gc_base
		${j9vm_SOURCE_DIR}/gc_stats
		${j9vm_SOURCE_DIR}/gc_structs
)

# Stub library to simplify programs which use makelib/cmain.c to provide a signal protected main
j9vm_add_library(j9vm_main_wrapper INTERFACE)
target_sources(j9vm_main_wrapper INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/makelib/cmain.c)
target_link_libraries(j9vm_main_wrapper
	INTERFACE
		j9thr
		j9prt
)

###

=== omr/compiler/env/CMakeLists.txt ===
###############################################################################
# Copyright IBM Corp. and others 2017
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution
# and is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following Secondary
# Licenses when the conditions for such availability set forth in the
# Eclipse Public License, v. 2.0 are satisfied: GNU General Public License,
# version 2 with the GNU Classpath Exception [1] and GNU General Public
# License, version 2 with the OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
#############################################################################

compiler_library(env
	${CMAKE_CURRENT_LIST_DIR}/ExceptionTable.cpp
	${CMAKE_CURRENT_LIST_DIR}/FrontEnd.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRCPU.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRObjectModel.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRArithEnv.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRClassEnv.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRDebugEnv.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRVMEnv.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRVMMethodEnv.cpp
	${CMAKE_CURRENT_LIST_DIR}/SegmentAllocator.cpp
	${CMAKE_CURRENT_LIST_DIR}/SegmentProvider.cpp
	${CMAKE_CURRENT_LIST_DIR}/SystemSegmentProvider.cpp
	${CMAKE_CURRENT_LIST_DIR}/DebugSegmentProvider.cpp
	${CMAKE_CURRENT_LIST_DIR}/Region.cpp
	${CMAKE_CURRENT_LIST_DIR}/StackMemoryRegion.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRPersistentInfo.cpp
	${CMAKE_CURRENT_LIST_DIR}/TRMemory.cpp
	${CMAKE_CURRENT_LIST_DIR}/TRPersistentMemory.cpp
	${CMAKE_CURRENT_LIST_DIR}/VerboseLog.cpp


	# The following are listed under JIT_PRODUCT_SOURCE_FILES
	# (for compiler test, but not jitbuilder).
	# TODO: figure out why and move if required
	${CMAKE_CURRENT_LIST_DIR}/OMRFrontEnd.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRJitConfig.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRIO.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRKnownObjectTable.cpp
	${CMAKE_CURRENT_LIST_DIR}/Globals.cpp
	${CMAKE_CURRENT_LIST_DIR}/OMRCompilerEnv.cpp
	${CMAKE_CURRENT_LIST_DIR}/PersistentAllocator.cpp

)

=== omr/fvtest/compilertriltest/CMakeLists.txt ===
###############################################################################
# Copyright IBM Corp. and others 2017
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution
# and is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following Secondary
# Licenses when the conditions for such availability set forth in the
# Eclipse Public License, v. 2.0 are satisfied: GNU General Public License,
# version 2 with the GNU Classpath Exception [1] and GNU General Public
# License, version 2 with the OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
###############################################################################

project(comptest LANGUAGES C CXX)

set(OMR_WARNINGS_AS_ERRORS OFF)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)
set(CMAKE_CXX_EXTENSIONS OFF)

# Add bigobj compiler options for TypeConversionTest.cpp under Windows
if(OMR_OS_WINDOWS)
	add_compile_options(-bigobj)
endif()

omr_add_executable(comptest NOWARNINGS
	main.cpp
	JitTest.cpp
	JitTestUtilitiesTest.cpp
	ILValidatorTest.cpp
	ArithmeticTest.cpp
	ShiftAndRotateTest.cpp
	SimplifierFoldAbsNegTest.cpp
	SimplifierFoldAndTest.cpp
	IfxcmpgeReductionTest.cpp
	VectorTest.cpp
	VectorMaskTest.cpp
	CallTest.cpp
	LongAndAsRotateTest.cpp
	MockStrategyTest.cpp
	LogicalTest.cpp
	LinkageTest.cpp
	BitPermuteTest.cpp
	MaxMinTest.cpp
	CompareTest.cpp
	TypeConversionTest.cpp
	SelectTest.cpp
	MinimalTest.cpp
	ArrayTest.cpp
)

target_link_libraries(comptest
	omrGtestGlue
	omrport
	tril
)

set_property(TARGET comptest PROPERTY FOLDER fvtest)

omr_add_test(
	NAME comptest
	COMMAND $<TARGET_FILE:comptest> --gtest_color=yes --gtest_output=xml:${CMAKE_CURRENT_BINARY_DIR}/comptest-results.xml
)

=== openj9/runtime/cfdumper/CMakeLists.txt ===
################################################################################
# Copyright IBM Corp. and others 2017
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
################################################################################

set(OMR_ENHANCED_WARNINGS OFF)

set_source_files_properties(${j9vm_BINARY_DIR}/vm/ut_j9vm.c PROPERTIES GENERATED TRUE)
j9vm_add_executable(cfdump
	main.c
	pvdump.c
	romdump.c
	stubs.c

	${j9vm_BINARY_DIR}/vm/ut_j9vm.c
	${j9vm_SOURCE_DIR}/vm/stringhelpers.cpp
	${j9vm_SOURCE_DIR}/vm/KeyHashTable.c
	${j9vm_SOURCE_DIR}/vm/ModularityHashTables.c
	${j9vm_SOURCE_DIR}/vm/dllsup.c
)
# We need to add an explicit dependency since CMake doesn't track dependencies for generated files across directories
add_dependencies(cfdump trc_j9vm)

# And add the vm binary dir to our include path
target_include_directories(cfdump PRIVATE ${j9vm_BINARY_DIR}/vm)

target_link_libraries(cfdump
	PRIVATE
		j9vm_interface
		j9vm_gc_includes
		j9vm_main_wrapper

		j9verutil
		j9exelib
		j9dyn
		j9bcv
		j9simplepool
		j9util
		j9utilcore
		j9avl
		j9hashtable
		j9hookable
		j9zip
		j9pool
		j9prt
		j9stackmap
		j9thr
		j9zlib
)

install(
	TARGETS cfdump
	RUNTIME DESTINATION ${j9vm_SOURCE_DIR}
)

=== openj9/runtime/compiler/CMakeLists.txt ===
################################################################################
# Copyright IBM Corp. and others 2017
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
################################################################################

include(CheckCXXCompilerFlag)
# This CMakeLists is included by the VM CMake lists, and works after composition
# has occurred.
#
# Relies on a few pieces of OMR, and a few pieces of the VM CMakeLists.
#
# Longer term, this will of course have to collapse into the VM builds.

if(OMR_ARCH_X86)
	# On Windows, the proper binary format is not auto detected.
	if(OMR_OS_WINDOWS)
		if(OMR_ENV_DATA64)
			set(CMAKE_ASM_NASM_OBJECT_FORMAT win64)
		else()
			set(CMAKE_ASM_NASM_OBJECT_FORMAT win32)
		endif()
	endif()
	enable_language(ASM_NASM)
	if(OMR_OS_WINDOWS)
		# On Windows, automatic dependency tracking for ASM_NASM files doesn't play
		# nicely with fixpath.sh. Remove the nasm options that would produce *.d
		# files: cmake silently treats missing *.d files as if they were empty.
		set(CMAKE_DEPFILE_FLAGS_ASM_NASM "")
	endif()
	# We have to manually append "/" to the paths as NASM versions older than v2.14 requires trailing / in the directory paths.
	set(asm_inc_dirs
		"-I${j9vm_SOURCE_DIR}/oti/"
		"-I${j9vm_BINARY_DIR}/oti/"
		"-I${CMAKE_CURRENT_SOURCE_DIR}/"
		"-I${CMAKE_CURRENT_SOURCE_DIR}/x/runtime/"
		"-I${CMAKE_CURRENT_SOURCE_DIR}/x/amd64/runtime/"
		"-I${CMAKE_CURRENT_SOURCE_DIR}/x/i386/runtime/"
	)
	omr_append_flags(CMAKE_ASM_NASM_FLAGS ${asm_inc_dirs})
	# For whatever reason cmake does not apply compile definitions when building nasm objects.
	# The if guard is here in case they ever start doing so.
	if(NOT CMAKE_ASM_NASM_COMPILE_OBJECT MATCHES "<DEFINES>")
		# Tack on defines immediately following the compiler name.
		string(REPLACE
			"<CMAKE_ASM_NASM_COMPILER>"
			"<CMAKE_ASM_NASM_COMPILER> <DEFINES>"
			CMAKE_ASM_NASM_COMPILE_OBJECT
			"${CMAKE_ASM_NASM_COMPILE_OBJECT}"
		)
	endif()
endif()

# Using the linker option -static-libgcc results in an error on OSX. The option -static-libstdc++ is unused.
# Therefore these options have been excluded from OSX.
if((OMR_TOOLCONFIG STREQUAL "gnu") AND (NOT OMR_OS_OSX))
	check_cxx_compiler_flag("-static-libstdc++" ALLOWS_STATIC_LIBCPP)
endif()

# This target is created so that various subdirectories can add dependencies to it.
# The j9jit target will then depend on it, propagating the dependencies.
# This is required because at the time we include the subdirectories, the j9jit target
# does not yet exist (and as such can't have dependencies addded to it).
add_custom_target(j9jit_generate)

# On Windows, exceptions are controlled via the preprocessor define _HAS_EXCEPTIONS.
# We need to enable it again, after OMR platform config removed it.
get_directory_property(compile_defs COMPILE_DEFINITIONS)
list(REMOVE_ITEM compile_defs "_HAS_EXCEPTIONS=0")
set_property(DIRECTORY PROPERTY COMPILE_DEFINITIONS ${compile_defs})

omr_add_tracegen(env/j9jit.tdf)

# this is a workaround because the JIT code includes the tracegen header as <env/ut_j9jit.h>
add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/env/ut_j9jit.h
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/ut_j9jit.h
	COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_BINARY_DIR}/ut_j9jit.h" "${CMAKE_CURRENT_BINARY_DIR}/env/ut_j9jit.h"
	VERBATIM
)

add_custom_target(j9jit_tracegen DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/env/ut_j9jit.h)

# J9VM_OPT_JITSERVER
if(J9VM_OPT_JITSERVER)
	message(STATUS "JITServer is enabled")

	if(OPENSSL_BUNDLE_LIB_PATH) # --enable-openssl-bundling
		set(OPENSSL_ROOT_DIR ${OPENSSL_BUNDLE_LIB_PATH})
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-rpath,$ORIGIN/..")
	elseif(OPENSSL_DIR) # --with-openssl=fetched only
		set(OPENSSL_ROOT_DIR ${OPENSSL_DIR})
	endif()

	find_package(OpenSSL REQUIRED)
	include_directories(${OPENSSL_INCLUDE_DIR})
endif()

# TODO We should get rid of this, but it's still required by the compiler_support module in OMR.
set(J9SRC ${j9vm_SOURCE_DIR})

# include compiler support module from OMR
include(OmrCompilerSupport)

# Override masm2gas with J9JIT version until we've
# resolved the divergence.
set(masm2gas_path build/scripts/masm2gas.pl )
get_filename_component(masm2gas_path ${masm2gas_path} ABSOLUTE)
set(MASM2GAS_PATH ${masm2gas_path} CACHE INTERNAL "MASM2GAS PATH")

# The list of files that are added to the compiler in addition
# To the defaults provided by create_omr_compiler_library
set(J9JIT_FILES "" CACHE INTERNAL "The computed list of j9jit files")

# Used inside added subdirectories to help
# fill in the object list
macro(j9jit_files)
	set(J9JIT_FILES ${J9JIT_FILES} ${ARGN} CACHE INTERNAL "The computed list of j9jit files")
endmacro(j9jit_files)

j9jit_files(${CMAKE_CURRENT_BINARY_DIR}/ut_j9jit.c)

# Add our subdirectories.
add_subdirectory(codegen)
add_subdirectory(compile)
add_subdirectory(control)
add_subdirectory(env)
add_subdirectory(il)
add_subdirectory(ilgen)
add_subdirectory(infra)
add_subdirectory(optimizer)
add_subdirectory(ras)
add_subdirectory(runtime)

if(J9VM_OPT_JITSERVER)
	add_subdirectory(net)
endif()

if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${TR_HOST_ARCH}")
	add_subdirectory(${TR_HOST_ARCH})
endif()

if(NOT TR_TARGET_ARCH STREQUAL TR_HOST_ARCH AND IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/${TR_TARGET_ARCH}")
	add_subdirectory(${TR_TARGET_ARCH})
endif()

# Some files in OMR provide duplicate or extra functionality not needed
# in J9, so we need to remove them.
set(REMOVED_OMR_FILES
	${omr_SOURCE_DIR}/compiler/codegen/CCData.cpp
	${omr_SOURCE_DIR}/compiler/control/CompileMethod.cpp
	${omr_SOURCE_DIR}/compiler/optimizer/FEInliner.cpp
	${omr_SOURCE_DIR}/compiler/env/OMRJitConfig.cpp
	${omr_SOURCE_DIR}/compiler/env/OMRFrontEnd.cpp
	${omr_SOURCE_DIR}/compiler/env/PersistentAllocator.cpp
	${omr_SOURCE_DIR}/compiler/env/SystemSegmentProvider.cpp
	${omr_SOURCE_DIR}/compiler/infra/OMRMonitor.cpp
	${omr_SOURCE_DIR}/compiler/runtime/Trampoline.cpp
	${omr_SOURCE_DIR}/compiler/runtime/Runtime.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/IlInjector.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRBytecodeBuilder.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRIlBuilder.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRIlType.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRIlValue.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRJitBuilderRecorder.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRJitBuilderRecorderBinaryBuffer.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRJitBuilderRecorderBinaryFile.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRJitBuilderRecorderTextFile.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRMethodBuilder.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRThunkBuilder.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRTypeDictionary.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRVirtualMachineOperandArray.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRVirtualMachineOperandStack.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRVirtualMachineRegister.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRVirtualMachineRegisterInStruct.cpp
	${omr_SOURCE_DIR}/compiler/ilgen/OMRVirtualMachineState.cpp
)

get_target_property(compiler_defines j9vm_compiler_defines INTERFACE_COMPILE_DEFINITIONS)
# Extra defines not provided by the create_omr_compiler_library call.
set(TARGET_DEFINES
	J9_PROJECT_SPECIFIC
	${compiler_defines}
)

# When VM is built with CMake, we should just use the
# INTERFACE specification of target_link_libraries,
# though that would also involve teaching MASM2GAS and
# PASM2ASM about target includes.
#
# In the meantime, like the makefiles, this is using
# the includes from the SDK.
set(J9_INCLUDES
	# From jitinclude.mk
	${omr_SOURCE_DIR}/thread
	${omr_SOURCE_DIR}/gc/include
	# endjitinclude.mk
	../ # Frustratingly there are some #include "frob/baz.hpp" references in the compiler which require this.
	${j9vm_SOURCE_DIR}/codert_vm
	${j9vm_SOURCE_DIR}/gc_include
	${j9vm_SOURCE_DIR}/gc_glue_java
	${j9vm_SOURCE_DIR}/jit_vm
	${j9vm_SOURCE_DIR}/nls
	${j9vm_SOURCE_DIR}/oti
	${j9vm_SOURCE_DIR}/include
	${j9vm_SOURCE_DIR}/util
	${j9vm_BINARY_DIR}
	${j9vm_BINARY_DIR}/oti
	${omr_BINARY_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
)

# Platform-specific lists of flags, derived directly from the makefiles.
set(J9_SHAREDFLAGS
	${OMR_PLATFORM_COMPILE_OPTIONS}
)
set(J9_CFLAGS
	${OMR_PLATFORM_C_COMPILE_OPTIONS}
)
set(J9_CXXFLAGS
	${OMR_PLATFORM_CXX_COMPILE_OPTIONS}
)

if(OMR_OS_LINUX OR OMR_OS_OSX)
	list(APPEND J9_SHAREDFLAGS
		-fno-strict-aliasing
		-Wno-deprecated
		-Wno-enum-compare
		-Wno-write-strings
		-fasynchronous-unwind-tables
		-Wreturn-type
		-pthread
	)
	# Workaround for problem seen in x86_64-macOS builds for JDK 22.
	if((NOT JAVA_SPEC_VERSION LESS 22) AND OMR_OS_OSX AND OMR_ARCH_X86)
		list(APPEND J9_SHAREDFLAGS
			-fno-omit-frame-pointer
		)
	else()
		list(APPEND J9_SHAREDFLAGS
			-fomit-frame-pointer
		)
	endif()

	# Platform-specific CXX flags, also derived from the makefiles.
	list(APPEND J9_CXXFLAGS
		-fno-threadsafe-statics
		-Wno-invalid-offsetof
	)
	if(OMR_ENV_DATA32)
		# avoid memset warnings, for warnings as errors
		list(APPEND J9_CXXFLAGS -Wno-stringop-overflow)
	endif()
	if(NOT J9VM_OPT_JITSERVER)
		list(APPEND J9_CXXFLAGS -fno-rtti)
	endif()

	list(APPEND J9_CFLAGS -std=gnu89)
elseif(OMR_OS_WINDOWS)
	list(APPEND J9_SHAREDFLAGS
		-D_WIN32
		-DWIN32
		-DSUPPORTS_THREAD_LOCAL
		-DWINDOWS
	)
elseif(OMR_OS_AIX)
	list(APPEND J9_SHAREDFLAGS
		-DAIXPPC
		-DRS6000
		-D_XOPEN_SOURCE_EXTENDED=1
		-D_ALL_SOURCE
		-DSUPPORTS_THREAD_LOCAL
	)
	if(OMR_ENV_DATA64)
		if(CMAKE_C_COMPILER_IS_OPENXL)
			list(APPEND J9_SHAREDFLAGS -m64)
		else()
			list(APPEND J9_SHAREDFLAGS -q64)
		endif()
		if(OMR_TOOLCONFIG STREQUAL "xlc")
			# Modify the arch tuning value we inherit from OMR.
			list(REMOVE_ITEM TR_COMPILE_OPTIONS "-qarch=pwr7")
			list(APPEND TR_COMPILE_OPTIONS "-qarch=ppc64grsq")

			if(CMAKE_C_COMPILER_IS_XLCLANG)
				# xlclang/xlclang++ options
				list(APPEND SPP_FLAGS -qlanglvl=extc99)
				set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -lc++")
			endif()
		endif()
	else()
		list(APPEND J9_SHAREDFLAGS -q32)
	endif()
elseif(OMR_OS_ZOS)
	list(APPEND TARGET_DEFINES
		J9VM_TIERED_CODE_CACHE
		MAXMOVE
	)
	set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -L/usr/lpp/hzc/lib")
else()
	message(SEND_ERROR "unsupported platform")
endif()

if(OMR_ARCH_S390)
	list(APPEND TARGET_DEFINES COMPRESS_AOT_DATA)
endif()

# Add optional user-specified compiler flags that only apply to the JIT.
list(APPEND J9_CFLAGS ${J9JIT_EXTRA_CFLAGS})
list(APPEND J9_CXXFLAGS ${J9JIT_EXTRA_CXXFLAGS})

# Note: J9_CFLAGS and J9_CXXFLAGS are appended after J9_SHAREDFLAGS so that
#       OMR_PLATFORM_C_COMPILE_OPTIONS and OMR_PLATFORM_CXX_COMPILE_OPTIONS
#       end up after OMR_PLATFORM_COMPILE_OPTIONS, which matches the rest
#       of the VM build (see cmake/modules/OmrPlatform.cmake in OMR).
#       This allows the user to pass extra compiler options via
#       OMR_PLATFORM_C_COMPILE_OPTIONS and OMR_PLATFORM_CXX_COMPILE_OPTIONS
#       to override the defaults specified by OMR_PLATFORM_COMPILE_OPTIONS,

=== openj9/runtime/ddr/CMakeLists.txt ===
################################################################################
# Copyright IBM Corp. and others 2019
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
################################################################################

set(OMR_ENHANCED_WARNINGS OFF)

j9vm_add_library(j9ddr_misc SHARED
	OUTPUT_NAME j9ddr_misc${J9VM_VERSION_SUFFIX}
	algorithm_versions.c
	gcddr.cpp
	jitflagsddr.c
	omrddr.cpp
	types.cpp
	vmddr.cpp
)

target_link_libraries(j9ddr_misc
	PRIVATE
		j9vm_interface
		j9vm_gc_includes
)
target_include_directories(j9ddr_misc
	PRIVATE
		${j9vm_SOURCE_DIR}/
		${j9vm_SOURCE_DIR}/bcutil
		${j9vm_BINARY_DIR}/bcutil
		${j9vm_SOURCE_DIR}/shared_common/include
		${j9vm_SOURCE_DIR}/compiler
		${omr_SOURCE_DIR}/compiler
)

# remove all optimization options so needed debugging information is not suppressed
omr_remove_flags(CMAKE_CXX_FLAGS -O -O1 -O2 -O3 /Ox)
omr_remove_flags(CMAKE_C_FLAGS -O -O1 -O2 -O3 /Ox)

if(OMR_TOOLCONFIG STREQUAL "gnu")
	# defining _FORTIFY_SOURCE is invalid when optimizations are disabled
	omr_remove_flags(CMAKE_C_FLAGS ${OMR_STRNCPY_FORTIFY_OPTIONS})
	omr_remove_flags(CMAKE_CXX_FLAGS ${OMR_STRNCPY_FORTIFY_OPTIONS})
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "XLClang")
	if(CMAKE_C_COMPILER_VERSION AND (CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL "17.1"))
		target_compile_options(j9ddr_misc PRIVATE -qdbxextra)
	endif()
elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
	target_compile_options(j9ddr_misc PRIVATE -fno-eliminate-unused-debug-types)
elseif(CMAKE_C_COMPILER_ID STREQUAL "GNU")
	target_compile_options(j9ddr_misc PRIVATE -femit-class-debug-always)
endif()

if(OMR_OS_AIX)
	target_link_libraries(j9ddr_misc
		PRIVATE
			-Wl,-bexpall
	)
endif()
target_enable_ddr(j9ddr_misc)
ddr_set_add_targets(j9ddr j9ddr_misc)

# At least one symbol must be exported, but because this shared library
# is only used by ddrgen it doesn't matter which name is exported.
omr_add_exports(j9ddr_misc getAlgorithmVersionStructTable)

=== openj9/runtime/jcl/CMakeLists.txt ===
################################################################################
# Copyright IBM Corp. and others 2017
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
################################################################################

set(J9VM_JCL_BIN_DIR "${CMAKE_CURRENT_BINARY_DIR}")

add_tracegen(j9jcl.tdf)
add_tracegen(jcl_java.tdf)
add_tracegen(jcl_net.tdf)
add_tracegen(jcl_nio.tdf)

j9vm_add_library(jclse SHARED
	OUTPUT_NAME jclse${J9VM_VERSION_SUFFIX}
	${CMAKE_CURRENT_BINARY_DIR}/ut_j9jcl.c
)

target_include_directories(jclse
	PRIVATE
		${CMAKE_CURRENT_SOURCE_DIR}
		${CMAKE_CURRENT_SOURCE_DIR}/common
		${j9vm_SOURCE_DIR}/shared_common/include
		${CMAKE_CURRENT_BINARY_DIR}
)

if(OMR_OS_WINDOWS)
	target_include_directories(jclse INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/win32)
else()
	target_include_directories(jclse INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/unix)
endif()

# Generate constant pool files
set(CONST_POOL_OUT_DIR "${j9vm_BINARY_DIR}")

# List of files generated by J9VMCPTool
set(gen_constpool_files "${CONST_POOL_OUT_DIR}/j9vmconstantpool.c")
if(OMR_OS_WINDOWS)
	set(JAVA_PATH_SEP ";")
else()
	set(JAVA_PATH_SEP ":")
endif()

# Dump the current cmake cache to text file
# We could just use CMakeCache.txt, but this way filters out advanced/internal variables and comments
add_custom_command(
	OUTPUT parsed_cache.txt
	COMMAND "${CMAKE_COMMAND}" -N -L > "${CMAKE_CURRENT_BINARY_DIR}/parsed_cache.txt"
	VERBATIM
	WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
)
add_custom_command(
	OUTPUT
		${gen_constpool_files}
	COMMAND "${Java_JAVA_EXECUTABLE}"
		-cp "$<TARGET_PROPERTY:j9vmcp,JAR_FILE>${JAVA_PATH_SEP}$<TARGET_PROPERTY:objectmodel,JAR_FILE>"
		com.ibm.oti.VMCPTool.Main
			-rootDir "${j9vm_SOURCE_DIR}"
			-outputDir "${CONST_POOL_OUT_DIR}"
			-cmakeCache "${CMAKE_CURRENT_BINARY_DIR}/parsed_cache.txt"
			-version ${JAVA_SPEC_VERSION}
	VERBATIM
	DEPENDS
		${j9vm_SOURCE_DIR}/oti/vmconstantpool.xml
		"${CMAKE_CURRENT_BINARY_DIR}/parsed_cache.txt"
		j9vmcp
		objectmodel
)
add_custom_target(run_cptool
	DEPENDS ${gen_constpool_files}
)
add_dependencies(j9vm_interface run_cptool)
set(cp_file_name ${CONST_POOL_OUT_DIR}/j9vmconstantpool.c)
set_source_files_properties(${cp_file_name} PROPERTIES GENERATED TRUE)
target_sources(jclse PRIVATE ${cp_file_name})

target_link_libraries(jclse
	PRIVATE
		j9vm_interface
		j9vm_gc_includes

		omrsig
		j9hookable
		j9zlib
		j9util
		j9utilcore
		j9avl
		j9hashtable
		j9pool
		j9thr
		sunvmi
)

target_sources(jclse
	PRIVATE
		${CMAKE_CURRENT_SOURCE_DIR}/common/annparser.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/attach.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/bootstrp.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/bpinit.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/clsldr.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/common/com_ibm_jvm_Stats.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/com_ibm_oti_vm_VM.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/common/compiler.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/dump.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/exhelp.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/extendedosmbean.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/getstacktrace.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/gpu.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/iohelp.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/java_lang_Access.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/java_lang_Class.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/common/java_lang_J9VMInternals.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/common/java_lang_ref_Finalizer.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/java_lang_ref_Reference.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/common/jclcinit.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/jcldefine.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/jclexception.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/common/jclglob.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/jclreflect.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/jcltrace.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/jclvm.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/jithelpers.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/jniidcacheinit.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/log.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtclassloading.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtcompilation.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtgc.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmthypervisor.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtinit.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtmemmgr.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtmemory.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtmempool.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtos.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtosext.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtruntime.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/mgmtthread.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/orbvmhelpers.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/proxy.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/reflecthelp.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/shared.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/sigquit.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/stdinit.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/sun_misc_Perf.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/sun_misc_Unsafe.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/common/sun_reflect_ConstantPool.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/system.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/thread.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/common/unsafe_mem.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/vminternals.c
		${CMAKE_CURRENT_SOURCE_DIR}/common/vm_scar.c
		${CMAKE_CURRENT_SOURCE_DIR}/filesys/vmfilesys.c
)

if(OMR_OS_WINDOWS)
	target_sources(jclse PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/win32/syshelp.c)
else()
	target_sources(jclse PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/unix/syshelp.c)
endif()

if(J9VM_INTERP_SIG_USR2)
	target_sources(jclse PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/common/sigusr2.c)
endif()

if(J9VM_OPT_METHOD_HANDLE)
	target_sources(jclse
		PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/common/java_dyn_methodhandle.c
			${CMAKE_CURRENT_SOURCE_DIR}/common/java_dyn_methodtype.c
	)
endif()

if(J9VM_OPT_OPENJDK_METHODHANDLE OR J9VM_OPT_METHOD_HANDLE)
	target_sources(jclse
		PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/common/java_lang_invoke_MethodHandleNatives.cpp
	)
endif()

if(J9VM_OPT_CRIU_SUPPORT)
	target_sources(jclse
		PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/common/criu.cpp
	)
endif()

if(JAVA_SPEC_VERSION EQUAL 8)
	# sources for Java 8 only
	target_sources(jclse
		PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/common/sun_misc_URLClassPath.c
	)
endif()

# We'd like to use GREATER_EQUAL here (and below), but that operator requires
# cmake version 3.7 or better; the minimum version we require is 3.4.
if(NOT JAVA_SPEC_VERSION LESS 9)
	# sources for Java 9+
	target_sources(jclse
		PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/common/java_lang_invoke_VarHandle.c
			${CMAKE_CURRENT_SOURCE_DIR}/common/java_lang_StackWalker.cpp
	)
endif()

# We'd like to use GREATER_EQUAL here (and below), but that operator requires
# cmake version 3.7 or better; the minimum version we require is 3.4.
if(NOT JAVA_SPEC_VERSION LESS 16)
	# sources for Java 16+
	target_sources(jclse
		PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_internal_foreign_abi_UpcallStubs.cpp
			${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_internal_misc_ScopedMemoryAccess.cpp
			${CMAKE_CURRENT_SOURCE_DIR}/common/vectornatives.cpp
	)
endif()

# We'd like to use GREATER_EQUAL here (and below), but that operator requires
# cmake version 3.7 or better; the minimum version we require is 3.4.
if(NOT JAVA_SPEC_VERSION LESS 19)
	# sources for Java 19+
	target_sources(jclse
		PRIVATE
			${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_internal_vm_Continuation.cpp
	)
endif()

if(JAVA_SPEC_VERSION LESS 24)
	target_sources(jclse PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/common/acccont.c)
endif()

if(J9VM_OPT_JFR)
	# JFR sources
	if(JAVA_SPEC_VERSION EQUAL 11)
		target_sources(jclse
			PRIVATE
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_common.cpp
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_jdk11.cpp
		)
	elseif(JAVA_SPEC_VERSION EQUAL 17)
		target_sources(jclse
			PRIVATE
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_common.cpp
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_jdk17.cpp
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_jdk17andUp.cpp
		)
	elseif(JAVA_SPEC_VERSION EQUAL 21)
		target_sources(jclse
			PRIVATE
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_common.cpp
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_jdk17andUp.cpp
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_jdk21andUp.cpp
		)
	elseif(NOT JAVA_SPEC_VERSION LESS 23)
		target_sources(jclse
			PRIVATE
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_common.cpp
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_jdk17andUp.cpp
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_jdk21andUp.cpp
				${CMAKE_CURRENT_SOURCE_DIR}/common/jdk_jfr_internal_JVM_jdk23.cpp
		)
	endif()
endif()

include(exports.cmake)

target_enable_ddr(jclse)
ddr_set_add_targets(j9ddr jclse)

install(
	TARGETS jclse
	LIBRARY DESTINATION ${j9vm_SOURCE_DIR}
	RUNTIME DESTINATION ${j9vm_SOURCE_DIR}
)

=== openj9/runtime/vm/CMakeLists.txt ===
################################################################################
# Copyright IBM Corp. and others 2017
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
################################################################################

omr_add_tracegen(j9vm.tdf)

if(OMR_TOOLCONFIG STREQUAL "msvc")
	# bypass omr provided warning flag handling, because we don't want
	# the warning flags to get passed to clang.
	# Note: the updated variables are scoped to this directory
	set(OMR_ENHANCED_WARNINGS OFF)
	set(OMR_WARNINGS_AS_ERRORS OFF)
	omr_append_flags(CMAKE_C_FLAGS ${OMR_C_ENHANCED_WARNINGS_FLAG} ${OMR_C_WARNINGS_AS_ERROR_FLAG})
	omr_append_flags(CMAKE_CXX_FLAGS ${OMR_CXX_ENHANCED_WARNINGS_FLAG} ${OMR_CXX_WARNINGS_AS_ERROR_FLAG})
endif()

set(interp_flags_to_remove) # list of flags removed when compiling the interpreter
set(interp_new_flags) # flags to be added when compiling the interpreter

# Note: the uma makefiles also specify this for pLinux, however it appears we no longer
# support building the interpreter with xlc on linux
if(OMR_ARCH_POWER AND OMR_OS_AIX)
	if(CMAKE_C_COMPILER_IS_OPENXL)
		# Fixes a performance defect related to PPC's handling of branch tables/indirect branch prediction
		list(APPEND interp_new_flags "-mllvm" "-ppc-min-jump-table-entries=512")
	elseif(OMR_TOOLCONFIG STREQUAL "xlc")
		list(APPEND interp_flags_to_remove "-O3" "-g")
		list(APPEND interp_new_flags "-O2" "-qdebug=lincomm:ptranl:tfbagg")
		# Note: the following code is specified in the UMA builds, however,
		# it isn't currently reachable, so it is block commneted out ( #[[ ]] )
		#[[
		if(OMR_OS_LINUX)
			# TODO -qpic=large -> -qpic
			# however at the moment all plinux builds with xlc use -qpic anyway
			list(APPEND interp_new_flags "-qmaxmem=-1")
		endif()
		]]
	endif()
elseif(OMR_OS_ZOS)
	if(OMR_TOOLCONFIG STREQUAL "openxl")
		# Hooks are not implemented in Open XL. The default debug compiles in Open XL will be NOHOOK
		# equivalent.
		list(APPEND interp_flags_to_remove "-O3" "-g")

		list(APPEND interp_new_flags -O2)
	else()
		# TODO need to handle optimized debug info
		list(APPEND interp_flags_to_remove "-O3" "-g" "-qdebug=nohook")

		list(APPEND interp_new_flags
			-O2
			"\"-Wc,TBYDBG(-qdebug=MRABIG)\""
			"\"-Wc,TBYDBG(-qdebug=lincomm:ptranl:tfbagg)\""
			"\"-Wc,FEDBG(-qxflag=InlineDespiteVolatileInArgs)\""
		)
	endif()
endif()

if(interp_flags_to_remove)
	# Keep track of which flags we have actually removed from CMAKE_CXX_FLAGS,
	# so that later we don't try re-adding flags that never existed
	set(removed_flags)
	foreach(flag IN LISTS interp_flags_to_remove)
		set(old_cxx_flags ${CMAKE_CXX_FLAGS})
		omr_remove_flags(CMAKE_CXX_FLAGS "${flag}")
		if(NOT old_cxx_flags STREQUAL CMAKE_CXX_FLAGS)
			list(APPEND removed_flags "${flag}")
		endif()
	endforeach()

	set(interp_flags_to_remove ${removed_flags})
endif()

set(main_sources
	annsup.c
	ArrayCopyHelpers.cpp
	AsyncMessageHandler.cpp
	bchelper.c
	bindnatv.cpp
	callin.cpp
	classallocation.c
	ClassInitialization.cpp
	classloadersearch.c
	classname.cpp
	classseg.c
	classsupport.c
	createramclass.cpp
	description.c
	dllsup.c
	drophelp.c
	EnsureHashedConfig.cpp
	exceptiondescribe.c
	exceptionsupport.c
	extendedMessageNPE.cpp
	FastJNI_com_ibm_oti_vm_VM.cpp
	FastJNI.cpp
	FastJNI_java_lang_Class.cpp
	FastJNI_java_lang_ClassLoader.cpp
	FastJNI_java_lang_invoke_MethodHandle.cpp
	FastJNI_java_lang_J9VMInternals.cpp
	FastJNI_java_lang_Object.cpp
	FastJNI_java_lang_reflect_Array.cpp
	FastJNI_java_lang_ref_Reference.cpp
	FastJNI_java_lang_String.cpp
	FastJNI_java_lang_System.cpp
	FastJNI_java_lang_Thread.cpp
	FastJNI_java_lang_Throwable.cpp
	FastJNI_sun_misc_Unsafe.cpp
	findmethod.c
	FlushProcessWriteBuffers.cpp
	gphandle.c
	growstack.cpp
	guardedstorage.c
	hookableAsync.c
	initsendtarget.cpp
	intfunc.c
	J9OMRHelpers.cpp
	javaPriority.c
	jnicgen.c
	jnicsup.cpp
	jnifield.cpp
	jniinv.c
	jnimem.c
	jnimisc.cpp
	jnireflect.cpp
	jvmfree.c
	jvminit.c
	jvminitcommon.c
	jvmrisup.c
	KeyHashTable.c
	LayoutFFITypeHelpers.cpp
	LayoutFFITypeTable.cpp
	leconditionexceptionsup.c
	linearswalk.c
	lockwordconfig.c
	logsupport.c
	lookuphelper.c
	lookupmethod.c
	ModularityHashTables.c
	monhelpers.c
	montable.c
	NativeHelpers.cpp
	ObjectFieldInfo.cpp
	ObjectMonitor.cpp
	OutOfLineINL_com_ibm_jit_JITHelpers.cpp
	OutOfLineINL_jdk_internal_misc_Unsafe.cpp
	OutOfLineINL_openj9_internal_foreign_abi_InternalDowncallHandler.cpp
	OutOfLineINL_openj9_internal_foreign_abi_InternalUpcallHandler.cpp
	OutOfLineINL_openj9_internal_foreign_abi_UpCallMHMetaData.cpp
	ownedmonitors.c
	profilingbc.c
	rasdump.c
	rastrace.c
	resolvefield.cpp
	resolvesupport.cpp
	romclasses.c
	romutil.c
	segment.c
	StackDumper.c
	statistics.c
	stringhelpers.cpp
	swalk.c
	threadhelp.cpp
	threadpark.cpp
	throwexception.c
	UpcallExceptionHandler.cpp
	UpcallThunkMem.cpp
	UpcallVMHelpers.cpp
	ValueTypeHelpers.cpp
	visible.c
	VMAccess.cpp
	vmbootlib.c
	vmhook.c
	vmifunc.c
	vmizip.c
	vmphases.c
	vmprops.c
	vmruntimestate.c
	VMSnapshotImpl.cpp
	vmthinit.c
	vmthread.cpp
	xcheck.c

	${CMAKE_CURRENT_BINARY_DIR}/ut_j9vm.c
)

if(J9VM_OPT_CRIU_SUPPORT)
	list(APPEND main_sources
		CRIUHelpers.cpp
	)
endif()

if(J9VM_OPT_JFR)
	list(APPEND main_sources
		jfr.cpp
		JFRConstantPoolTypes.cpp
		JFRChunkWriter.cpp
	)
endif()

if(NOT JAVA_SPEC_VERSION LESS 19)
	list(APPEND main_sources
		ContinuationHelpers.cpp
	)
endif()

set(interpreter_sources
	BytecodeInterpreterCompressed.cpp
	BytecodeInterpreterFull.cpp
	DebugBytecodeInterpreterCompressed.cpp
	DebugBytecodeInterpreterFull.cpp
)

if(J9VM_OPT_METHOD_HANDLE)
	list(APPEND interpreter_sources
		MHInterpreterCompressed.cpp
		MHInterpreterFull.cpp
	)
endif()

j9vm_add_library(j9vm SHARED
	OUTPUT_NAME j9vm${J9VM_VERSION_SUFFIX}
	${main_sources}
	${interpreter_sources}
)

if(interp_flags_to_remove)
	# Since we removed the flags from CMAKE_CXX_FLAGS, we need to add them back
	# to everything except the compiler
	set(cpp_sources)
	foreach(srcfile IN LISTS main_sources)
		get_filename_component(extension "${srcfile}" EXT)
		if(extension STREQUAL ".cpp")
			list(APPEND cpp_sources "${srcfile}")
		endif()
	endforeach()

	# COMPILE_FLAGS property expects a string, not a list
	omr_stringify(flags_str ${interp_flags_to_remove})
	set_property(SOURCE ${cpp_sources} APPEND_STRING PROPERTY COMPILE_FLAGS " ${flags_str}")
endif()

if(interp_new_flags)
	# COMPILE_FLAGS property expects a string, not a list
	omr_stringify(flags_str ${interp_new_flags})
	set_property(SOURCE ${interpreter_sources} APPEND_STRING PROPERTY COMPILE_FLAGS " ${flags_str}")
endif()

if(OMR_OS_WINDOWS AND (OMR_TOOLCONFIG STREQUAL "msvc"))
	# JIT helper methods require us to disable buffer security checks on Windows
	# See https://github.com/eclipse-openj9/openj9/pull/1494 for rationale
	set_property(
		SOURCE
			cnathelp.cpp
			SharedService.c
		APPEND PROPERTY COMPILE_FLAGS "/GS-"
	)

	# Use J9VM_CXX compiler (aka clang) to build the interpreter
	enable_language(J9VM_CXX)
	set_source_files_properties(
		${interpreter_sources}
		PROPERTIES
		LANGUAGE J9VM_CXX
	)
endif()

if(OMR_ARCH_X86)
	j9vm_gen_asm(xcinterp.m4)

	if(OMR_OS_LINUX OR OMR_OS_OSX)
		if(OMR_ENV_DATA64)
			j9vm_gen_asm(
				xa64/stackswap.m4
				xa64/unsafeHelper.m4
			)
			target_sources(j9vm PRIVATE
				unsafeHelper.s
				xa64/UpcallThunkGen.cpp
			)
		else()
			j9vm_gen_asm(xi32/stackswap.m4)
			target_sources(j9vm PRIVATE xi32/unsafeHelper.s)
		endif()
	elseif(OMR_OS_WINDOWS)
		if(OMR_ENV_DATA64)
			j9vm_gen_asm(wa64/stackswap.m4)
			target_sources(j9vm PRIVATE wa64/UpcallThunkGen.cpp)
		else()
			j9vm_gen_asm(wi32/stackswap.m4)
			target_sources(j9vm PRIVATE
				wi32/inlineseh.c
				safeseh.asm
			)

			set_source_files_properties(safeseh.asm PROPERTIES LANGUAGE ASM_MASM)
		endif()
	else()
		message(SEND_ERROR "Unsupported platform")
	endif()

	target_sources(j9vm
		PRIVATE
			xcinterp.s
			stackswap.s
	)
elseif(OMR_ARCH_POWER)
	j9vm_gen_asm(pcinterp.m4)
	target_sources(j9vm PRIVATE pcinterp.s)
	if(OMR_OS_LINUX)
		if(NOT (OMR_ENV_DATA64 AND OMR_ENV_LITTLE_ENDIAN))
			message(SEND_ERROR "Only PPC64 LE is currently supported")
		endif()
		target_sources(j9vm PRIVATE
			xl64/unsafeHelper.s
			xl64/UpcallThunkGen.cpp
		)
	elseif(OMR_OS_AIX)
		if(OMR_ENV_DATA64)
			target_sources(j9vm PRIVATE
				ap64/unsafeHelper.s
				ap64/UpcallThunkGen.cpp
			)
		else()
			target_sources(j9vm PRIVATE ap32/unsafeHelper.s)
		endif()
		if(OMR_TOOLCONFIG STREQUAL "xlc")
			# Suppress warning "Infinite loop. Program may not stop"
			target_compile_options(j9vm PRIVATE "-qsuppress=1500-010")
		endif()
	else()
		message(SEND_ERROR "Unsupported platfrom")
	endif()
elseif(OMR_ARCH_S390)
	j9vm_gen_asm(zcinterp.m4)
	target_sources(j9vm PRIVATE zcinterp.s)
	if(OMR_OS_LINUX)
		if(OMR_ENV_DATA64)
			target_sources(j9vm PRIVATE
				xz64/unsafeHelper.s
				xz64/UpcallThunkGen.cpp
			)
		else()
			target_sources(j9vm PRIVATE xz31/unsafeHelper.s)
		endif()
	elseif(OMR_OS_ZOS)
		if(OMR_ENV_DATA64)
			target_sources(j9vm PRIVATE
				mz64/unsafeHelper.s
				mz64/UpcallThunkGen.cpp
			)
		else()
			target_sources(j9vm PRIVATE
				mz31/unsafeHelper.s
				inlineleconditionhandler.c
				leconditionexceptionsup.c
			)
		endif()
	else()
		message(SEND_ERROR "Unsupported platform")
	endif()
elseif(OMR_ARCH_ARM)
	j9vm_gen_asm(armcinterp.m4)
	target_sources(j9vm PRIVATE armcinterp.s)
	if(OMR_OS_LINUX)
		target_sources(j9vm PRIVATE xr32/unsafeHelper.s)
	else()
		message(SEND_ERROR "Unsupported OS")
	endif()
elseif(OMR_ARCH_AARCH64)
	j9vm_gen_asm(arm64cinterp.m4)
	target_sources(j9vm PRIVATE arm64cinterp.s)
	if(OMR_OS_LINUX OR OMR_OS_OSX)
		j9vm_gen_asm(xr64/unsafeHelper.m4)
		target_sources(j9vm PRIVATE
			unsafeHelper.s
			xr64/UpcallThunkGen.cpp
			)
	else()
		message(SEND_ERROR "Unsupported OS")
	endif()
elseif(OMR_ARCH_RISCV)
	if(OMR_ENV_DATA64)
		j9vm_gen_asm(riscvcinterp.m4)
		target_sources(j9vm PRIVATE riscvcinterp.s)
		if(OMR_OS_LINUX)
			target_sources(j9vm PRIVATE rv64/unsafeHelper.s)
		else()
			message(SEND_ERROR "Unsupported OS")
		endif()
	else()
		message(SEND_ERROR "Unsupported platform: RV32")
	endif()
else()
	message(SEND_ERROR "Unsupported platform")
endif()

target_include_directories(j9vm
	PRIVATE
		${j9vm_SOURCE_DIR}/shared_common/include
		${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(j9vm
	PRIVATE
		j9vm_interface
		j9vm_gc_includes

		omrcore
		j9verutil
		j9thr
		j9util
		j9utilcore
		j9avl
		j9hashtable
		j9pool
		j9stackmap
		j9hookable
		j9prt
		j9bcv
		j9dyn
		j9simplepool
		j9zip
		ffi

		# link hacks
		# TODO: figure out why CMake needs these, but UMA does not
		j9util
		j9simplepool
		j9verutil
		j9stackmap
		j9bcv
		j9dyn
		j9util
		j9thr
)

target_compile_definitions(j9vm
	PRIVATE
		-DJ9_EXTENDED_DEBUG
)

omr_add_exports(j9vm
	J9_CreateJavaVM
	J9_GetCreatedJavaVMs
	J9_GetInterface
)

if(J9VM_INTERP_TRACING)
	omr_add_exports(j9vm trace)
endif()

target_enable_ddr(j9vm GLOB_HEADERS)
ddr_set_add_targets(j9ddr j9vm)

install(
	TARGETS j9vm
	LIBRARY DESTINATION ${j9vm_SOURCE_DIR}
	RUNTIME DESTINATION ${j9vm_SOURCE_DIR}
)

=== openj9/runtime/compiler/env/CMakeLists.txt ===
################################################################################
# Copyright IBM Corp. and others 2017
#
# This program and the accompanying materials are made available under
# the terms of the Eclipse Public License 2.0 which accompanies this
# distribution and is available at https://www.eclipse.org/legal/epl-2.0/
# or the Apache License, Version 2.0 which accompanies this distribution and
# is available at https://www.apache.org/licenses/LICENSE-2.0.
#
# This Source Code may also be made available under the following
# Secondary Licenses when the conditions for such availability set
# forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
# General Public License, version 2 with the GNU Classpath
# Exception [1] and GNU General Public License, version 2 with the
# OpenJDK Assembly Exception [2].
#
# [1] https://www.gnu.org/software/classpath/license.html
# [2] https://openjdk.org/legal/assembly-exception.html
#
# SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
################################################################################

j9jit_files(
	env/annotations/AnnotationBase.cpp
	env/annotations/Annotations.cpp
	env/annotations/GPUAnnotation.cpp
	env/annotations/TestAnnotation.cpp
	env/annotations/TRNoSideFXAnnotation.cpp
	env/annotations/TROptAnnotation.cpp
	env/annotations/VMJ9Annotations.cpp
	env/CHTable.cpp
	env/ClassLoaderTable.cpp
	env/CpuUtilization.cpp
	env/DependencyTable.cpp
	env/FilePointer.cpp
	env/J2IThunk.cpp
	env/J9ArithEnv.cpp
	env/J9ClassEnv.cpp
	env/J9CompilerEnv.cpp
	env/J9CPU.cpp
	env/J9DebugEnv.cpp
	env/j9fieldsInfo.cpp
	env/J9IO.cpp
	env/J9JitMemory.cpp
	env/J9KnownObjectTable.cpp
	env/j9method.cpp
	env/J9ObjectModel.cpp
	env/J9PersistentInfo.cpp
	env/J9SegmentAllocator.cpp
	env/J9SegmentCache.cpp
	env/J9SegmentProvider.cpp
	env/J9SharedCache.cpp
	env/J9VMEnv.cpp
	env/J9VMMethodEnv.cpp
	env/jitsupport.cpp
	env/PersistentAllocator.cpp
	env/PersistentCHTable.cpp
	env/ProcessorDetection.cpp
	env/Startup.cpp
	env/SystemSegmentProvider.cpp
	env/VMJ9.cpp
)

if(J9VM_OPT_JITSERVER)
	j9jit_files(
		env/j9methodServer.cpp
		env/JITServerCHTable.cpp
		env/JITServerPersistentCHTable.cpp
		env/VMJ9Server.cpp
	)
endif()

## openj9-21 0.53.0

=== debian/changelog ===
openj9-21 (0.53.0-1) unstable; urgency=medium

  * Upgrade upstream

 -- Mathieu Baudier <mbaudier@argeo.org>  Thu, 07 Aug 2025 14:03:02 +0000

=== debian/control ===
Source: openj9-21
Section: java
Priority: optional
Maintainer: Mathieu Baudier <mbaudier@argeo.org>
Build-Depends: openjdk-21-jdk-headless | openj9-20-headless,
 g++-12 [amd64], gcc-12 [amd64], g++-10 [arm64], gcc-10 [arm64], debhelper-compat (= 13), build-essential,
 ca-certificates, cmake, cpio, curl, file, git,
 libasound2-dev, libcups2-dev, libdwarf-dev, libelf-dev, libexpat1-dev, libffi-dev, libfontconfig, libfontconfig1-dev, libfreetype6-dev, libnuma-dev,
 libssl-dev, libx11-dev, libxext-dev, libxrandr-dev, libxrender-dev, libxt-dev, libxtst-dev, make, nasm, pkg-config, systemtap-sdt-dev,
 unzip, wget, xvfb, zip, zlib1g-dev,
 libgif-dev, libjpeg-dev, libpng-dev, liblcms2-dev, libharfbuzz-dev, libxinerama-dev, libkrb5-dev, libpcsclite-dev, libxrandr-dev,
 nvidia-cuda-dev, nvidia-cuda-toolkit
Standards-Version: 4.5.1
Homepage: https://www.eclipse.org/openj9/
Vcs-Git: https://code.argeo.org/restricted/deb/openj9.git
Rules-Requires-Root: binary-targets

Package: openj9-21
Architecture: any
Priority: optional
Depends: java-common,
	util-linux, libstdc++6, zlib1g,
	openssl, libgssapi-krb5-2
Description: OpenJ9 JVM with OpenJDK
 OpenJ9 is an alternative Java Virtual Machine (instead of HotSpot). This package has very few dependencies in order to minimise install space, so not all Java features will be working.

Package: openj9-21-jmods
Architecture: any
Priority: optional
Description: OpenJ9 JVM with OpenJDK (jmods)

Package: openj9-21-source
Architecture: any
Priority: optional
Depends: openj9-21
Description: OpenJ9 JVM with OpenJDK (source)

Package: openj9-21-headless
Architecture: any
Priority: optional
Depends: openj9-21,
	libnss3, libpcsclite1, libgcc-s1,
	libfreetype6, libfontconfig1, libcups2, libharfbuzz0b,
	libjpeg62-turbo, libpng16-16, libgif7
Description: Meta-package with the dependencies for a fully functional headless JDK based on OpenJ9

Package: openj9-21-cuda
Architecture: any
Priority: optional
Depends: openj9-21-headless,
	libcuda1
Description: Meta-package adding the (non-free) dependencies for the CUDA features of OpenJ9

Package: openj9-21-desktop
Architecture: any
Priority: optional
Depends: openj9-21-headless,
	fonts-dejavu-extra,
	liblcms2-2, libasound2,
	libgtk-3-0, libxrandr2, libxinerama1, libxrender1, libxrender1, libgl1, libxtst6, libxext6, libxi6, libx11-6
Description: Meta-package with the dependencies for a fully functional desktop JDK based on OpenJ9

Package: openj9-21-sdk
Architecture: any
Priority: optional
Depends: openj9-21-desktop, openj9-21-source, openj9-21-jmods
Description: Meta-package with the dependencies for a fully functional Java development environment based on OpenJ9

#	, libgtk-3-0, libxrandr2, libxinerama1, libgl1-mesa-glx

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

unexport LANG LC_ALL

version_date = $(shell date --iso-8601)

# Linux-style architecture
LINUX_HOST_ARCH=$(shell uname -m)

# Use OpenJDK as bootstrap if it exists
ifneq (,$(wildcard /usr/lib/jvm/java-21-openjdk-$(DEB_HOST_ARCH)))
BOOT_JDK=/usr/lib/jvm/java-21-openjdk-$(DEB_HOST_ARCH)
else
BOOT_JDK=/usr/lib/jvm/java-20-openj9-$(DEB_HOST_ARCH)
endif

ifeq ($(DEB_HOST_ARCH),arm64)
GCC_VERSION=10
WITH_OPENSSL=fetched
else
GCC_VERSION=12
WITH_OPENSSL=system
endif

# Same naming as in openjdk official Debian build
origin		= openj9
shortver	= 21
jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
ifneq ($(OPENJ9_MARCH),)
jdirname   += $(jdirname)-$(OPENJ9_MARCH)
endif
d_jvmlib	= /usr/lib/jvm
basedir	= $(d_jvmlib)/$(jdirname)

basename	= $(origin)-$(shortver)
p_jrehl	= $(basename)
d_jrehl	= debian/$(p_jrehl)

absarchdir = $(CURDIR)/$(d_jrehl)/$(basedir)/lib
shlibdeps_ld_path =$(absarchdir):$(absarchdir)/j9vm:$(absarchdir)/compressedrefs

dpkg_buildflags_hs = \
	DEB_BUILD_MAINT_OPTIONS="$(DEB_BUILD_MAINT_OPTIONS)" \
	DEB_CFLAGS_MAINT_STRIP="-O3 -Wno-error" \
	DEB_CXXFLAGS_MAINT_STRIP="-O3 -Wno-error" \
	DEB_CFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations" \
	DEB_CXXFLAGS_MAINT_APPEND="-fno-stack-protector -Wno-deprecated-declarations$(if $(filter $(DEB_HOST_ARCH), armel armhf), -fpermissive)"
# jdk/make/CompileDemos.gmk (SetupJVMTIDemo) doesn't like commas in flags
dpkg_buildflags_hs += \
	DEB_LDFLAGS_MAINT_STRIP="-Wl,-z,relro -Wl,-Bsymbolic-functions" \
	DEB_LDFLAGS_MAINT_APPEND="-Xlinker -z -Xlinker relro -Xlinker -Bsymbolic-functions"
dpkg_buildflags_hs += dpkg-buildflags
export EXTRA_CPPFLAGS_HS := $(shell $(dpkg_buildflags_hs) --get CPPFLAGS)
export EXTRA_CFLAGS_HS   := $(shell $(dpkg_buildflags_hs) --get CFLAGS; $(dpkg_buildflags_hs) --get CPPFLAGS)
export EXTRA_CXXFLAGS_HS := $(shell $(dpkg_buildflags_hs) --get CXXFLAGS) -Wno-deprecated-declarations
export EXTRA_LDFLAGS_HS  := $(shell $(dpkg_buildflags_hs) --get LDFLAGS)

ifneq ($(OPENJ9_MARCH),)
EXTRA_CPPFLAGS_HS += -march=$(OPENJ9_MARCH)
endif

ifneq ($(LINUX_HOST_ARCH),aarch64)
ENABLE_JITSERVER=--enable-jitserver
endif

# actually work on bookworm
DISABLE_DDR=--disable-ddr

# Extra Argeo flags
# -fpermissive: avoid issues with newer compilers
# -DNDEBUG: disable assertions
#EXTRA_CPPFLAGS_ARGEO=-Wno-narrowing -Wno-error=narrowing -DNDEBUG
#EXTRA_CXXFLAGS_ARGEO=-fpermissive

%:
	dh $@

override_dh_auto_clean:
	if [ -d "./build" ]; then make dist-clean; rm -rf ./build; fi
	rm -f *.log

override_dh_auto_configure:
	bash ./configure \
	$(ENABLE_JITSERVER) \
	$(DISABLE_DDR) \
	--with-extra-cflags='$(EXTRA_CPPFLAGS_ARGEO) $(EXTRA_CFLAGS_ARGEO) $(EXTRA_CPPFLAGS_HS) $(EXTRA_CFLAGS_HS) $(CFLAGS)' \
	--with-extra-cxxflags='$(EXTRA_CPPFLAGS_ARGEO) $(EXTRA_CXXFLAGS_ARGEO) $(EXTRA_CPPFLAGS_HS) $(EXTRA_CXXFLAGS_HS) $(CXXFLAGS)' \
	--with-extra-ldflags='$(EXTRA_LDFLAGS_HS) $(LDFLAGS)' \
	--enable-cuda --with-cuda=/usr \
	--with-jni-libpath=/usr/lib/$(DEB_HOST_MULTIARCH)/jni:/usr/lib/jni:/lib/jni:$(basedir)/lib:/usr/lib/$(DEB_HOST_MULTIARCH):/usr/lib:/lib/$(DEB_HOST_MULTIARCH):/lib \
	--disable-warnings-as-errors \
	--disable-warnings-as-errors-omr \
	--disable-warnings-as-errors-openj9 \
	--with-debug-level=release \
	--with-openj9-cc=/usr/bin/$(LINUX_HOST_ARCH)-linux-gnu-gcc-$(GCC_VERSION) \
	--with-openj9-cxx=/usr/bin/$(LINUX_HOST_ARCH)-linux-gnu-g++-$(GCC_VERSION) \
	--with-stdc++lib=dynamic \
	--with-openssl=$(WITH_OPENSSL) \
	--with-libjpeg=system \
	--with-giflib=system \
	--with-libpng=system \
	--with-zlib=system \
	--with-lcms=system \
	--with-harfbuzz=system \
	--with-freetype=system \
	--with-version-pre=argeo \
	--with-version-opt= \
	--with-version-date=$(version_date) \
	--with-boot-jdk=$(BOOT_JDK)/

override_dh_auto_build:
	make jdk-image

override_dh_auto_test:
	echo Skip tests

override_dh_auto_install:
	#find ./build/ -name "*debuginfo" -delete
	mkdir -p $(CURDIR)/$(d_jrehl)/usr/lib/jvm
	
	# copy the whole built JDK and then dispatch files to the subpackages 
	cp -rp ./build/linux-$(LINUX_HOST_ARCH)-server-release/images/jdk $(CURDIR)/$(d_jrehl)/$(basedir)
	
	cp debian/.java-$(shortver)-openj9-$(DEB_HOST_ARCH).jinfo $(CURDIR)/$(d_jrehl)/usr/lib/jvm/
	
	# jmods
	mkdir -p $(CURDIR)/$(d_jrehl)-jmods/$(basedir)
	mv $(CURDIR)/$(d_jrehl)/$(basedir)/jmods $(CURDIR)/$(d_jrehl)-jmods/$(basedir)
	
	# source
	mkdir -p $(CURDIR)/$(d_jrehl)-source/$(basedir)/lib
	mv $(CURDIR)/$(d_jrehl)/$(basedir)/lib/src.zip $(CURDIR)/$(d_jrehl)-source/$(basedir)/lib
	
override_dh_shlibdeps:
	dh_shlibdeps -a -L $(p_jrehl) -l$(shlibdeps_ld_path) --

override_dh_dwz:
	echo Disable dh_dwz since it is failing

# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
